/*
 * Copyright 2018 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jbpm.workbench.forms.client.display.displayer;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.kie.workbench.common.forms.dynamic.service.shared.FormRenderingContext;
import org.mockito.Mock;
import org.mockito.runners.MockitoJUnitRunner;

import static org.mockito.Matchers.any;
import static org.mockito.Matchers.eq;
import static org.mockito.Mockito.verify;

@RunWith(MockitoJUnitRunner.class)
public class KieWorkbenchFormDisplayerTest {

    @Mock
    private KieWorkbenchFormDisplayerView view;

    @Mock
    private FormRenderingContext ctx;

    private KieWorkbenchFormDisplayer displayer;

    @Before
    public void init() {
        displayer = new KieWorkbenchFormDisplayer(view);
    }

    @Test
    public void testFunctionality() {
        displayer.getElement();

        verify(view).getElement();

        displayer.isValid();

        verify(view).isValid();

        displayer.show(ctx, true);

        verify(view).show(any(), eq(true));

        displayer.show(ctx, false);

        verify(view).show(any(), eq(false));
    }
}
